package ka_deploy_cluster;

# Author : Daniel Viard <dviard@mandrakesoft.com>
# Version 0.1
# please report bug to: cooker@mandrakesoft.com

use strict;
use Term::ANSIColor;
use MDK::Common;
use cluster_clientconf;
use cluster_commonconf;
use cluster_fonction_common;

# test root capa
AmIRoot();

###################################################################################
# retrieve rescue stage from SERVER
###################################################################################
sub retrieve_rescue {
  print '- Downloading rescue stage from server (' . cluster_clientconf::catch_dhcp()->{NEXT_SERVER} . ")\n";
  my $WORK_DIR = cluster_commonconf::ka_data()->{WORK_DIR};
  my $tftpserver = cluster_clientconf::catch_dhcp()->{NEXT_SERVERIP};
  my $rescue2 = cluster_commonconf::ka_data()->{RESCUE2};
  open(FTP_CMD, "| cd $WORK_DIR ; tftp $tftpserver");
  print FTP_CMD "get $rescue2\n";
  print FTP_CMD "quit\n";
  close FTP_CMD;
  print "\n";
}


###################################################################################
# Bunzip Rescue
###################################################################################
sub bunzip_rescue {
  print "- Bunziping rescue stage\n";
  sys('bunzip2 ' . cluster_commonconf::ka_data()->{WORK_DIR} . '/' . cluster_commonconf::ka_data()->{RESCUE2});
}

###################################################################################
# mount ka
###################################################################################
sub mount_ka {
  print "- Mounting rescue stage in loopback\n";
  sys('mount ' . cluster_commonconf::ka_data()->{WORK_DIR} . '/' . cluster_commonconf::ka_data()->{RESCUE} . ' ' . cluster_commonconf::ka_data()->{KA_MNT} . ' -o loop');
}

###################################################################################
# umount ka
###################################################################################
sub umount_ka {
  print "- Umounting ka\n";
  eval { sys('umount ' . cluster_commonconf::ka_data()->{KA_MNT} . ' 2>/dev/null') };
}

###################################################################################
# Checking path
###################################################################################
sub check_path {
  print "- Checking path\n";
  if (! -e cluster_commonconf::ka_data()->{KA_MNT}) {
    mkdir_p(cluster_commonconf::ka_data()->{KA_MNT});
  }
}

###################################################################################
# Remove old version of rescue
###################################################################################
sub remove_old {
  print "- Removing old version\n";
  if (-e cluster_commonconf::ka_data()->{WORK_DIR} . cluster_commonconf::ka_data()->{RESCUE}) {
    rm_rf(cluster_commonconf::ka_data()->{WORK_DIR} . cluster_commonconf::ka_data()->{RESCUE});
  } else {
    print cluster_commonconf::ka_data()->{WORK_DIR} . cluster_commonconf::ka_data()->{RESCUE} . " does not exist.\n";
  }
}

###################################################################################
# MAIN program
###################################################################################
sub main {
  check_path();
  umount_ka();
  remove_old();
  retrieve_rescue();
  bunzip_rescue();
  mount_ka();
  print " !!! KA is now ready to deploy !!!\n";
}

1;
